﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using CrystalDecisions.CrystalReports.Engine;
using NLog;
using Microsoft.Windows.Controls.Ribbon;

namespace CrystalReportLocationSetter
{
    /// <summary>
    /// Interaction logic for MainView.xaml
    /// </summary>
    public partial class MainView : RibbonWindow
    {
        private static Logger _logger = LogManager.GetCurrentClassLogger();

        private CrlsViewModel ViewModel { get; set; }

        public MainView()
        {
            InitializeComponent();
            DataContext = ViewModel = new CrlsViewModel();
        }

        private void reportListBox_Drop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);

                foreach (string file in files)
                {
                    var doc = new CrlsReportDocument();
                    
                    if (System.IO.Path.GetExtension(file) == ".rpt")
                    {   
                        try
                        {
                            _logger.Log(LogLevel.Trace, String.Format("Loading {0}", file));
                            doc.Load(file);
                            ViewModel.Reports.Add(doc);
                        }
                        catch (Exception ex)
                        {
                            _logger.LogException(LogLevel.Error, "Error: ", ex);
                        }
                    }
                }
            }
        }

        private void reportListBox_DragEnter(object sender, DragEventArgs e)
        {
            if (!e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effects = DragDropEffects.None;
            }
        }

        private void ExitButton_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Application.Current.Shutdown();
        }

     
    }
}
